'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('@recipher/form');

var _table = require('@recipher/table');

var _users = require('./users');

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var member = _ref.member,
      results = _ref.results,
      users = _ref.users,
      add = _ref.add,
      invite = _ref.invite,
      remove = _ref.remove,
      search = _ref.search;

  return _react2.default.createElement(
    'div',
    null,
    results.fetched && results.data.length === 0 && _react2.default.createElement(_users.Message, { text: 'No users found' }),
    results.data.map(function (user) {
      return _react2.default.createElement(_user2.default, { key: user.id, user: user, member: member, users: users, onAdd: add, onRemove: remove });
    }),
    _react2.default.createElement(_table.Empty, { limit: results.meta.query.limit, length: results.data.length }),
    results.meta.total > results.meta.query.limit && _react2.default.createElement(_table.Paging, { meta: results.meta, fetching: results.fetching, search: search, entity: 'user' })
  );
};