'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Message = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _user = require('./user');

var _user2 = _interopRequireDefault(_user);

var _table = require('@recipher/table');

var _icons = require('@recipher/icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Message = exports.Message = function Message(_ref) {
  var text = _ref.text,
      _ref$Icon = _ref.Icon,
      Icon = _ref$Icon === undefined ? _icons.Warning : _ref$Icon,
      _ref$rotate = _ref.rotate,
      rotate = _ref$rotate === undefined ? false : _ref$rotate,
      _ref$colour = _ref.colour,
      colour = _ref$colour === undefined ? '#666' : _ref$colour;

  return _react2.default.createElement(
    'div',
    { style: { padding: '4px 12px 4px 0', position: 'relative' } },
    _react2.default.createElement(Icon, { rotate: rotate, style: { marginTop: -4 }, colour: colour, size: 24 }),
    _react2.default.createElement(
      'span',
      { style: { paddingLeft: 15 } },
      text
    )
  );
};

var Users = function (_Component) {
  _inherits(Users, _Component);

  function Users() {
    _classCallCheck(this, Users);

    return _possibleConstructorReturn(this, (Users.__proto__ || Object.getPrototypeOf(Users)).apply(this, arguments));
  }

  _createClass(Users, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          member = _props.member,
          users = _props.users,
          search = _props.search,
          add = _props.add,
          remove = _props.remove;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'p',
          { style: { color: '#666', margin: '-5px 0 10px 0', paddingTop: 5 } },
          'Set user permissions'
        ),
        users.fetching && _react2.default.createElement(Message, { text: 'Loading...', rotate: true, Icon: _icons.Spinner }),
        users.data.map(function (user) {
          return _react2.default.createElement(_user2.default, { key: user.id, user: user, users: users, member: member, onAdd: add, onRemove: remove });
        }),
        _react2.default.createElement(_table.Empty, { limit: users.meta.query.limit, length: users.data.length }),
        users.meta.total > users.meta.query.limit && _react2.default.createElement(_table.Paging, { meta: users.meta, fetching: users.fetching, search: search, entity: 'user' })
      );
    }
  }]);

  return Users;
}(_react.Component);

exports.default = Users;
;