'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _icons = require('@recipher/icons');

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _table = require('@recipher/table');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _table.State)('account')(function (_ref) {
  var account = _ref.account,
      authorized = _ref.authorized,
      onConnect = _ref.onConnect,
      onDisconnect = _ref.onDisconnect,
      dispatch = _ref.dispatch,
      $ = _ref.$,
      state = _ref.state;

  var events = (0, _table.Events)({ dispatch: dispatch, $: $, id: account.id });

  return _react2.default.createElement(
    _table.Row,
    { onMouseOver: events.over, onMouseOut: events.out },
    _react2.default.createElement(
      _table.Cell,
      { width: '10%' },
      _react2.default.createElement(_icon2.default, { authorized: authorized, size: 24, network: account.network, onConnect: onConnect, shape: 'square' })
    ),
    _react2.default.createElement(
      _table.Cell,
      { width: '80%' },
      _react2.default.createElement(
        'a',
        { href: account.link, style: { paddingLeft: 0, textDecoration: 'none', color: '#333', fontSize: '1.1em' }, target: '_blank' },
        account.name || account.link
      )
    ),
    _react2.default.createElement(
      _table.Cell,
      { width: '10%', align: 'right', hide: !authorized || !state[account.id] },
      _react2.default.createElement(
        'a',
        { onClick: function onClick(_) {
            return authorized && onDisconnect(account);
          }, style: { cursor: 'pointer' } },
        _react2.default.createElement(_icons.Close, { style: { marginTop: -4 } })
      )
    )
  );
});