'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _account = require('./account');

var _account2 = _interopRequireDefault(_account);

var _component = require('@recipher/component');

var _icons = require('@recipher/icons');

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _feed = require('./feed');

var _feed2 = _interopRequireDefault(_feed);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Message = function Message(_ref) {
  var text = _ref.text,
      _ref$Icon = _ref.Icon,
      Icon = _ref$Icon === undefined ? _icons.Spinner : _ref$Icon,
      _ref$rotate = _ref.rotate,
      rotate = _ref$rotate === undefined ? true : _ref$rotate,
      _ref$colour = _ref.colour,
      colour = _ref$colour === undefined ? '#666' : _ref$colour;

  return _react2.default.createElement(
    'div',
    { style: { padding: '4px 12px 4px 0' } },
    _react2.default.createElement(Icon, { rotate: rotate, style: { marginTop: -4 }, colour: colour, size: 24 }),
    _react2.default.createElement(
      'span',
      { style: { paddingLeft: 15, color: colour } },
      text
    )
  );
};

var Connect = function (_Component) {
  _inherits(Connect, _Component);

  function Connect() {
    _classCallCheck(this, Connect);

    return _possibleConstructorReturn(this, (Connect.__proto__ || Object.getPrototypeOf(Connect)).apply(this, arguments));
  }

  _createClass(Connect, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          authorized = _props.authorized,
          disconnect = _props.disconnect,
          connectTo = _props.connectTo,
          connectRss = _props.connectRss,
          connectPage = _props.connectPage,
          accounts = _props.accounts;


      return _react2.default.createElement(
        'div',
        { 'data-test': 'connect-form' },
        _react2.default.createElement(
          'p',
          { style: { color: '#666', margin: '-5px 0 10px 0', paddingTop: 5, clear: 'both' } },
          'Connect your social accounts and RSS feeds by clicking the icons below.'
        ),
        _react2.default.createElement(_icon2.default, { authorized: authorized, network: 'facebook', onConnect: connectTo }),
        _react2.default.createElement(_icon2.default, { authorized: authorized, network: 'twitter', onConnect: connectTo }),
        _react2.default.createElement(_icon2.default, { authorized: authorized, network: 'google', onConnect: connectTo }),
        _react2.default.createElement(_feed2.default, { authorized: authorized, onConnect: connectRss, type: 'rss', title: 'Connect RSS Feed' }),
        _react2.default.createElement(_component.Rule, null),
        accounts.data.map(function (account) {
          return _react2.default.createElement(_account2.default, { authorized: authorized, key: account.id, account: account, onConnect: connectTo, onDisconnect: disconnect });
        }),
        accounts.isFetching && _react2.default.createElement(Message, { text: 'Loading...' }),
        accounts.isConnecting && _react2.default.createElement(Message, { text: 'Connecting...' }),
        accounts.data.length === 0 && !accounts.isFetching && accounts.isFetched && _react2.default.createElement(Message, { rotate: false, text: 'No connected accounts. Please connect now.', Icon: _icons.Err, colour: '#a95252' })
      );
    }
  }]);

  return Connect;
}(_react.Component);

exports.default = Connect;