'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Connection = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _assign = require('lodash/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _find = require('lodash/collection/find');

var _find2 = _interopRequireDefault(_find);

var _icons = require('@recipher/icons');

var _navigation = require('@recipher/navigation');

var _table = require('@recipher/table');

var _connections = require('../../data/connections');

var _connections2 = _interopRequireDefault(_connections);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Connect = function Connect(_ref) {
  var connection = _ref.connection,
      member = _ref.member,
      conn = _ref.conn,
      onChange = _ref.onChange,
      onRemove = _ref.onRemove;

  var items = [{ Icon: _icons.Menu, name: connection.id, title: conn.description, align: 'right',
    style: { dropdown: { top: 26, right: 0 } },
    submenu: (0, _connections2.default)(connection.connectedTo).map(function (c) {
      return { title: c.action,
        onClick: function onClick(_) {
          return onChange(member, connection, c.type);
        },
        active: conn.type === c.type };
    })
  }];

  items[0].submenu.push({ divider: true });
  items[0].submenu.push({ title: 'Disconnect',
    onClick: function onClick(_) {
      return onRemove(member, connection);
    }, active: false });

  return _react2.default.createElement(_navigation.Menu, { items: items, style: { margin: 0 } });
};

var Action = function Action(_ref2) {
  var member = _ref2.member,
      connection = _ref2.connection,
      existing = _ref2.existing,
      onAdd = _ref2.onAdd,
      onChange = _ref2.onChange,
      onRemove = _ref2.onRemove;

  var conn = existing && (0, _find2.default)((0, _connections2.default)(connection.connectedTo), { type: existing.type });

  var add = [{ title: 'Follow', Icon: _icons.Menu, onClick: function onClick(_) {
      return onAdd(member, { memberId: connection.connectedTo.id, type: 'follows' });
    } }];

  return _react2.default.createElement(
    'span',
    null,
    conn && _react2.default.createElement(Connect, { conn: conn, connection: existing, member: member, onChange: onChange, onRemove: onRemove }),
    !existing && _react2.default.createElement(_navigation.Menu, { items: add, style: { margin: 0 } })
  );
};

var Connection = exports.Connection = function Connection(_ref3) {
  var member = _ref3.member,
      connection = _ref3.connection,
      connections = _ref3.connections,
      onAdd = _ref3.onAdd,
      onChange = _ref3.onChange,
      onRemove = _ref3.onRemove,
      state = _ref3.state,
      dispatch = _ref3.dispatch,
      $ = _ref3.$;

  var events = (0, _table.Events)({ dispatch: dispatch, $: $, id: connection.id });

  var existing = (0, _find2.default)(connections.data, function (conn) {
    return conn.connectedTo.id === connection.connectedTo.id;
  });

  var onClick = !existing ? function (_) {
    return onAdd(member, { memberId: connection.connectedTo.id, type: 'follows' });
  } : null,
      style = !existing ? {} : { cursor: 'default' };

  return _react2.default.createElement(
    _table.Row,
    { onMouseOver: events.over, onMouseOut: events.out, onClick: onClick, style: style },
    _react2.default.createElement(
      _table.Cell,
      { width: '65%' },
      _react2.default.createElement(
        'strong',
        null,
        connection.connectedTo.name,
        ' '
      )
    ),
    _react2.default.createElement(
      _table.Cell,
      { width: '35%', align: 'right', hide: !existing && !state[connection.id] },
      _react2.default.createElement(Action, { existing: existing, connection: connection, member: member, onAdd: onAdd, onChange: onChange, onRemove: onRemove })
    )
  );
};

exports.default = (0, _table.State)('connection')(Connection);