'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Message = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _connection = require('./connection');

var _connection2 = _interopRequireDefault(_connection);

var _table = require('@recipher/table');

var _icons = require('@recipher/icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Message = exports.Message = function Message(_ref) {
  var text = _ref.text,
      _ref$Icon = _ref.Icon,
      Icon = _ref$Icon === undefined ? _icons.Warning : _ref$Icon,
      _ref$rotate = _ref.rotate,
      rotate = _ref$rotate === undefined ? false : _ref$rotate,
      _ref$colour = _ref.colour,
      colour = _ref$colour === undefined ? '#666' : _ref$colour;

  return _react2.default.createElement(
    'div',
    { style: { padding: '4px 12px 4px 0', position: 'relative' } },
    _react2.default.createElement(Icon, { rotate: rotate, style: { marginTop: -4 }, colour: colour, size: 24 }),
    _react2.default.createElement(
      'span',
      { style: { paddingLeft: 15 } },
      text
    )
  );
};

var Connections = function (_Component) {
  _inherits(Connections, _Component);

  function Connections() {
    _classCallCheck(this, Connections);

    return _possibleConstructorReturn(this, (Connections.__proto__ || Object.getPrototypeOf(Connections)).apply(this, arguments));
  }

  _createClass(Connections, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          member = _props.member,
          connections = _props.connections,
          search = _props.search,
          add = _props.add,
          change = _props.change,
          remove = _props.remove;


      if (connections.data.length === 0 && connections.fetched) return _react2.default.createElement(Message, { text: 'No connections' });

      return _react2.default.createElement(
        'div',
        null,
        connections.fetching && _react2.default.createElement(Message, { text: 'Loading...', rotate: true, Icon: _icons.Spinner }),
        connections.data.map(function (connection) {
          return _react2.default.createElement(_connection2.default, { key: connection.id, connection: connection, connections: connections, member: member,
            onChange: change, onAdd: add, onRemove: remove });
        }),
        _react2.default.createElement(_table.Empty, { limit: connections.meta.query.limit, length: connections.data.length }),
        connections.meta.total > connections.meta.query.limit && _react2.default.createElement(_table.Paging, { meta: connections.meta, fetching: connections.fetching, search: search, entity: 'member' })
      );
    }
  }]);

  return Connections;
}(_react.Component);

exports.default = Connections;
;