'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _form = require('@recipher/form');

var _table = require('@recipher/table');

var _connections = require('./connections');

var _connection = require('./connection');

var _connection2 = _interopRequireDefault(_connection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
  var member = _ref.member,
      results = _ref.results,
      connections = _ref.connections,
      add = _ref.add,
      change = _ref.change,
      remove = _ref.remove,
      search = _ref.search;

  return _react2.default.createElement(
    'div',
    null,
    results.fetched && results.data.length === 0 && _react2.default.createElement(_connections.Message, { text: 'No members found' }),
    results.data.map(function (result) {
      return _react2.default.createElement(_connection2.default, { key: result.id, connection: { id: result.id, connectedTo: result }, member: member, connections: connections,
        onAdd: add, onChange: change, onRemove: remove });
    }),
    _react2.default.createElement(_table.Empty, { limit: results.meta.query.limit, length: results.data.length }),
    results.meta.total > results.meta.query.limit && _react2.default.createElement(_table.Paging, { meta: results.meta, fetching: results.fetching, search: search, entity: 'member' })
  );
};