'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign2 = require('lodash/object/assign');

var _assign3 = _interopRequireDefault(_assign2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _reduxForm = require('redux-form');

var _reduxReactLocal = require('redux-react-local');

var _icons = require('@recipher/icons');

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _form = require('@recipher/form');

var _component = require('@recipher/component');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var options = { form: 'feed', fields: ['link'] };

var Dialog = (0, _reduxForm.reduxForm)(options)(function (_ref) {
  var display = _ref.display,
      type = _ref.type,
      title = _ref.title,
      fields = _ref.fields,
      handleSubmit = _ref.handleSubmit,
      onClosed = _ref.onClosed;

  var styles = {
    content: {
      top: '50%',
      left: '50%',
      right: 'auto',
      bottom: 'auto',
      marginRight: '-50%',
      transform: 'translate(-50%, -50%)',
      padding: '10px 20px 20px 20px',
      borderRadius: 0
    }
  };

  return _react2.default.createElement(
    _reactModal2.default,
    { id: type, style: styles, isOpen: display, closeTimeoutMS: 150, shouldCloseOnOverlayClick: true, onRequestClose: onClosed },
    _react2.default.createElement(
      _form.Form,
      { onSubmit: handleSubmit },
      _react2.default.createElement(
        _component.Heading,
        null,
        title
      ),
      _react2.default.createElement(_form.Input, { label: 'URL', field: fields.link, focus: true, Icon: _icon.Icons[type] }),
      _react2.default.createElement(_form.Button, { label: 'Connect', onClick: handleSubmit }),
      _react2.default.createElement(_form.Button, { label: 'cancel', kind: 'link', onClick: onClosed })
    )
  );
});

exports.default = (0, _reduxReactLocal.local)({
  ident: 'feed',
  initial: {},
  reducer: function reducer(state, _ref2) {
    var me = _ref2.me,
        meta = _ref2.meta;

    return me ? (0, _assign3.default)({}, state, _defineProperty({}, meta.type, !state[meta.type])) : state;
  }
})(function (_ref3) {
  var colour = _ref3.colour,
      onConnect = _ref3.onConnect,
      type = _ref3.type,
      title = _ref3.title,
      authorized = _ref3.authorized,
      state = _ref3.state,
      dispatch = _ref3.dispatch,
      $ = _ref3.$;

  var styles = {
    base: {
      position: 'relative',
      paddingTop: 2,
      cursor: 'pointer'
    }
  };

  var onSubmit = function onSubmit(props) {
    onConnect(props);
    dispatch($({ type: type }));
    dispatch((0, _reduxForm.reset)('feed'));
  };

  var toggle = function toggle(e) {
    if (e && e.preventDefault) e.preventDefault();
    dispatch($({ type: type }));
  };

  return _react2.default.createElement(
    'span',
    { style: styles.base },
    _react2.default.createElement(_icon2.default, { authorized: authorized, network: type, onConnect: toggle }),
    _react2.default.createElement(Dialog, { onSubmit: onSubmit, onClosed: toggle, type: type, title: title, display: authorized && state[type] })
  );
});