'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Icons = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _icons = require('@recipher/icons');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Icons = exports.Icons = {
  facebook: _icons.Facebook,
  twitter: _icons.Twitter,
  google: _icons.YouTube,
  instagram: _icons.Instagram,
  rss: _icons.Rss,
  page: _icons.Facebook
};

exports.default = (0, _radium2.default)(function (_ref) {
  var authorized = _ref.authorized,
      network = _ref.network,
      onConnect = _ref.onConnect,
      colour = _ref.colour,
      _ref$size = _ref.size,
      size = _ref$size === undefined ? 36 : _ref$size,
      style = _ref.style,
      _ref$shape = _ref.shape,
      shape = _ref$shape === undefined ? 'circle' : _ref$shape;

  var styles = {
    base: {
      cursor: 'pointer',
      paddingRight: 15
    },
    notAuthorized: {
      cursor: 'not-allowed'
    }
  };

  var Icon = Icons[network];

  return _react2.default.createElement(
    'a',
    { onClick: function onClick() {
        return authorized && onConnect(network);
      }, style: [styles.base, !authorized && styles.notAuthorized] },
    _react2.default.createElement(Icon, { size: size, style: style, shape: shape, colour: !authorized ? '#999' : undefined })
  );
});