'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Member = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _table = require('@recipher/table');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Mark = function Mark(_ref) {
  var colour = _ref.colour;

  var styles = {
    base: {
      position: 'absolute',
      width: 12,
      height: 7,
      background: 'transparent',
      top: 4,
      right: 3,
      borderLeft: '3px solid ' + colour,
      borderBottom: '3px solid ' + colour,
      borderTop: 'none',
      borderRight: 'none',
      transform: 'rotate(-45deg)'
    }
  };

  return _react2.default.createElement('span', { style: styles.base });
};

var Member = exports.Member = (0, _table.State)('member')((0, _radium2.default)(function (_ref2) {
  var member = _ref2.member,
      selected = _ref2.selected,
      user = _ref2.user,
      setPrimary = _ref2.setPrimary,
      state = _ref2.state,
      dispatch = _ref2.dispatch,
      $ = _ref2.$;

  var events = (0, _table.Events)({ dispatch: dispatch, $: $, id: member.id });

  var styles = {
    base: {
      fontWeight: 700,
      color: '#000',
      opacity: 0.7,
      transition: 'all 0.4s ease-in-out',
      ':hover': {
        opacity: 1
      }
    },
    isSelected: {
      color: '#2185d0',
      opacity: 1
    }
  };

  var isSelected = member.id === selected.id,
      onClick = isSelected ? null : function (_) {
    return setPrimary(member, user);
  };

  return _react2.default.createElement(
    _table.Row,
    { onMouseOver: events.over, onMouseOut: events.out, onClick: onClick, style: isSelected && { cursor: 'default' } },
    _react2.default.createElement(
      _table.Cell,
      { width: '65%' },
      _react2.default.createElement(
        'span',
        { style: [styles.base, isSelected && styles.isSelected] },
        member.name,
        ' '
      )
    ),
    _react2.default.createElement(
      _table.Cell,
      { width: '35%', align: 'right', hide: !isSelected && !state[member.id], style: { position: 'relative' } },
      _react2.default.createElement(Mark, { colour: isSelected ? '#2185d0' : '#999' })
    )
  );
}));

exports.default = function (_ref3) {
  var members = _ref3.members,
      member = _ref3.member,
      session = _ref3.session,
      setPrimary = _ref3.setPrimary;

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      'p',
      { style: { color: '#666', margin: '-5px 0 10px 0', paddingTop: 5 } },
      'Select the active member'
    ),
    members.data.map(function (m) {
      return _react2.default.createElement(Member, { key: m.id, member: m, selected: member, user: session.user, setPrimary: setPrimary });
    })
  );
};