'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Connections = exports.Access = exports.Edit = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _navigation = require('@recipher/navigation');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Nav = function Nav(_ref) {
  var items = _ref.items;

  var styles = {
    base: {
      fontSize: 20,
      padding: '5px 0 0 0',
      '@media (max-width: 639px)': {
        fontSize: 18,
        padding: '0 0 5px 0'
      }
    }
  };

  return _react2.default.createElement(_navigation.Menu, { items: items, style: styles.base });
};

var Edit = exports.Edit = function Edit(_) {
  var items = [{ to: '/member', title: 'Edit Member' }, { to: '/member/connect', title: 'Connect Accounts' }];

  return _react2.default.createElement(Nav, { items: items });
};

var Access = exports.Access = function Access(_ref2) {
  var _ref2$member = _ref2.member;
  _ref2$member = _ref2$member === undefined ? {} : _ref2$member;
  var id = _ref2$member.id;

  var items = [{ to: '/member/access', title: 'Manage Access' }, { to: '/member/access/add', title: 'Add User', claim: 'manage ' + id }];

  return _react2.default.createElement(Nav, { items: items });
};

var Connections = exports.Connections = function Connections(_ref3) {
  var _ref3$member = _ref3.member;
  _ref3$member = _ref3$member === undefined ? {} : _ref3$member;
  var id = _ref3$member.id;

  var items = [{ to: '/member/connections', title: 'Manage Connections' }, { to: '/member/connections/add', title: 'Connect', claim: 'manage ' + id }];

  return _react2.default.createElement(Nav, { items: items });
};