'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Profile = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxForm = require('redux-form');

var _form = require('@recipher/form');

var _members = require('../ducks/members');

var _icons = require('@recipher/icons');

var _profile = require('../validate/profile');

var _profile2 = _interopRequireDefault(_profile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Profile = exports.Profile = function (_Component) {
  _inherits(Profile, _Component);

  function Profile() {
    _classCallCheck(this, Profile);

    return _possibleConstructorReturn(this, (Profile.__proto__ || Object.getPrototypeOf(Profile)).apply(this, arguments));
  }

  _createClass(Profile, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          fields = _props.fields,
          _props$button = _props.button,
          button = _props$button === undefined ? ['Save', 'Saving...'] : _props$button,
          authorized = _props.authorized,
          _props$members = _props.members,
          changing = _props$members.changing,
          error = _props$members.error,
          handleSubmit = _props.handleSubmit;


      return _react2.default.createElement(
        _form.Form,
        { onSubmit: handleSubmit, authorized: authorized },
        _react2.default.createElement(_form.Input, { label: 'Member Name', field: fields.name, focus: true }),
        _react2.default.createElement(_form.TextArea, { label: 'Bio', field: fields.bio, minRows: 6 }),
        _react2.default.createElement(_form.Button, { label: changing ? button[1] : button[0],
          disabled: changing, onClick: handleSubmit }),
        _react2.default.createElement(
          _form.Message,
          null,
          error
        )
      );
    }
  }]);

  return Profile;
}(_react.Component);

;

exports.default = (0, _reduxForm.reduxForm)({
  form: 'profile',
  fields: ['name', 'bio'],
  validate: _profile2.default })(Profile);