'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resultsSelector = exports.CLEAR = exports.FAILED = exports.SUCCESS = exports.SEARCH = exports.schema = undefined;
exports.search = search;
exports.clear = clear;

var _assign = require('lodash/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _resource = require('@recipher/resource');

var _entities = require('@recipher/entities');

var _normalizr = require('normalizr');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var schema = exports.schema = new _normalizr.Schema('users');

var SEARCH = exports.SEARCH = 'recipher/member/search/FETCH';
var SUCCESS = exports.SUCCESS = 'recipher/member/search/SUCCESS';
var FAILED = exports.FAILED = 'recipher/member/search/FAILED';
var CLEAR = exports.CLEAR = 'recipher/member/search/CLEAR';

exports.default = (0, _entities.entitiesReducer)([SEARCH, SUCCESS, FAILED, CLEAR]);
var resultsSelector = exports.resultsSelector = (0, _entities.entitiesSelector)(function (state) {
  return state.member.search;
}, 'users');

function search(data) {
  var query = (0, _assign2.default)({}, { q: '', page: 1, limit: _entities.LIMIT }, data);

  return _defineProperty({}, _resource.RESOURCE, {
    types: [SEARCH, SUCCESS, FAILED],
    payload: {
      url: '/users/search',
      method: 'get',
      query: query,
      normalize: function normalize(r) {
        return (0, _normalizr.normalize)(r.users, (0, _normalizr.arrayOf)(schema));
      }
    },
    meta: { query: query }
  });
};

function clear() {
  return { type: CLEAR };
};