'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Profile = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reselect = require('reselect');

var _reactRedux = require('react-redux');

var _support = require('@recipher/support');

var _members = require('../ducks/members');

var _navigation = require('../components/navigation');

var _profile = require('../components/profile');

var _profile2 = _interopRequireDefault(_profile);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Profile = exports.Profile = function (_Component) {
  _inherits(Profile, _Component);

  function Profile(props) {
    _classCallCheck(this, Profile);

    var _this = _possibleConstructorReturn(this, (Profile.__proto__ || Object.getPrototypeOf(Profile)).call(this, props));

    _this.handleSubmit = _this.handleSubmit.bind(_this);
    return _this;
  }

  _createClass(Profile, [{
    key: 'handleSubmit',
    value: function handleSubmit(data) {
      var _props = this.props,
          member = _props.member,
          update = _props.update;

      update(member, data);
    }
  }, {
    key: 'render',
    value: function render() {
      var member = this.props.member;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_navigation.Edit, null),
        _react2.default.createElement(_profile2.default, _extends({}, this.props, { onSubmit: this.handleSubmit, initialValues: member }))
      );
    }
  }]);

  return Profile;
}(_react.Component);

;

var mapStateToProps = (0, _reselect.createStructuredSelector)({
  member: _members.memberSelector,
  members: _members.membersSelector,
  session: function session(state) {
    return state.session;
  },
  authorized: (0, _support.authorizeSelector)(_support.Update, _members.primarySelector)
});

exports.default = (0, _reactRedux.connect)(mapStateToProps, { update: _members.update })(Profile);