'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = connect;
exports.resetAccounts = resetAccounts;
exports.fetchAccountsOnFetchMember = fetchAccountsOnFetchMember;
exports.fetchAccountsOnSetPrimary = fetchAccountsOnSetPrimary;

var _frieze = require('frieze');

var _effects = require('redux-saga/effects');

var _members = require('../ducks/members');

var _accounts = require('../ducks/accounts');

var _marked = [connect, resetAccounts, fetchAccountsOnFetchMember, fetchAccountsOnSetPrimary].map(regeneratorRuntime.mark);

function connect() {
  var _ref, payload;

  return regeneratorRuntime.wrap(function connect$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!true) {
            _context.next = 14;
            break;
          }

          _context.next = 3;
          return (0, _effects.take)(_accounts.CONNECT_FAILED);

        case 3:
          _ref = _context.sent;
          payload = _ref.payload;

          if (!(payload.status === 404)) {
            _context.next = 10;
            break;
          }

          _context.next = 8;
          return (0, _effects.put)((0, _frieze.error)('That account is already connected to another member.'));

        case 8:
          _context.next = 12;
          break;

        case 10:
          _context.next = 12;
          return (0, _effects.put)((0, _frieze.error)('There was an error connecting your account.'));

        case 12:
          _context.next = 0;
          break;

        case 14:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
};

function resetAccounts() {
  return regeneratorRuntime.wrap(function resetAccounts$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!true) {
            _context2.next = 7;
            break;
          }

          _context2.next = 3;
          return (0, _effects.take)(_members.CREATE_SUCCESS);

        case 3:
          _context2.next = 5;
          return (0, _effects.put)({ type: _accounts.RESET });

        case 5:
          _context2.next = 0;
          break;

        case 7:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this);
};

function fetchAccountsOnFetchMember() {
  return regeneratorRuntime.wrap(function fetchAccountsOnFetchMember$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          if (!true) {
            _context3.next = 11;
            break;
          }

          _context3.next = 3;
          return (0, _effects.take)(_members.FETCH_SUCCESS);

        case 3:
          _context3.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context3.t0 = _context3.sent;
          _context3.t1 = (0, _accounts.fetch)(_context3.t0);
          _context3.next = 9;
          return (0, _effects.put)(_context3.t1);

        case 9:
          _context3.next = 0;
          break;

        case 11:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked[2], this);
};

function fetchAccountsOnSetPrimary() {
  return regeneratorRuntime.wrap(function fetchAccountsOnSetPrimary$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          if (!true) {
            _context4.next = 11;
            break;
          }

          _context4.next = 3;
          return (0, _effects.take)(_members.SET_PRIMARY_SUCCESS);

        case 3:
          _context4.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context4.t0 = _context4.sent;
          _context4.t1 = (0, _accounts.fetch)(_context4.t0);
          _context4.next = 9;
          return (0, _effects.put)(_context4.t1);

        case 9:
          _context4.next = 0;
          break;

        case 11:
        case 'end':
          return _context4.stop();
      }
    }
  }, _marked[3], this);
};