'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetConnections = resetConnections;
exports.fetchConnectionsOnFetchMember = fetchConnectionsOnFetchMember;
exports.fetchConnectionsOnSetPrimary = fetchConnectionsOnSetPrimary;

var _effects = require('redux-saga/effects');

var _members = require('../ducks/members');

var _connections = require('../ducks/connections');

var _marked = [resetConnections, fetchConnectionsOnFetchMember, fetchConnectionsOnSetPrimary].map(regeneratorRuntime.mark);

function resetConnections() {
  return regeneratorRuntime.wrap(function resetConnections$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!true) {
            _context.next = 7;
            break;
          }

          _context.next = 3;
          return (0, _effects.take)(_members.CREATE_SUCCESS);

        case 3:
          _context.next = 5;
          return (0, _effects.put)({ type: _connections.RESET });

        case 5:
          _context.next = 0;
          break;

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
};

function fetchConnectionsOnFetchMember() {
  return regeneratorRuntime.wrap(function fetchConnectionsOnFetchMember$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!true) {
            _context2.next = 11;
            break;
          }

          _context2.next = 3;
          return (0, _effects.take)(_members.FETCH_SUCCESS);

        case 3:
          _context2.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context2.t0 = _context2.sent;
          _context2.t1 = (0, _connections.fetch)(_context2.t0);
          _context2.next = 9;
          return (0, _effects.put)(_context2.t1);

        case 9:
          _context2.next = 0;
          break;

        case 11:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this);
};

function fetchConnectionsOnSetPrimary() {
  return regeneratorRuntime.wrap(function fetchConnectionsOnSetPrimary$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          if (!true) {
            _context3.next = 11;
            break;
          }

          _context3.next = 3;
          return (0, _effects.take)(_members.SET_PRIMARY_SUCCESS);

        case 3:
          _context3.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context3.t0 = _context3.sent;
          _context3.t1 = (0, _connections.fetch)(_context3.t0);
          _context3.next = 9;
          return (0, _effects.put)(_context3.t1);

        case 9:
          _context3.next = 0;
          break;

        case 11:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked[2], this);
};