'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetUsers = resetUsers;
exports.fetchUsersOnFetchMember = fetchUsersOnFetchMember;
exports.fetchUsersOnSetPrimary = fetchUsersOnSetPrimary;
exports.invited = invited;

var _reactRouterRedux = require('react-router-redux');

var _frieze = require('frieze');

var _reduxForm = require('redux-form');

var _effects = require('redux-saga/effects');

var _members = require('../ducks/members');

var _users = require('../ducks/users');

var _search = require('../ducks/search');

var _marked = [resetUsers, fetchUsersOnFetchMember, fetchUsersOnSetPrimary, invited].map(regeneratorRuntime.mark);

function resetUsers() {
  return regeneratorRuntime.wrap(function resetUsers$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          if (!true) {
            _context.next = 7;
            break;
          }

          _context.next = 3;
          return (0, _effects.take)(_members.CREATE_SUCCESS);

        case 3:
          _context.next = 5;
          return (0, _effects.put)({ type: _users.RESET });

        case 5:
          _context.next = 0;
          break;

        case 7:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
};

function fetchUsersOnFetchMember() {
  return regeneratorRuntime.wrap(function fetchUsersOnFetchMember$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          if (!true) {
            _context2.next = 11;
            break;
          }

          _context2.next = 3;
          return (0, _effects.take)(_members.FETCH_SUCCESS);

        case 3:
          _context2.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context2.t0 = _context2.sent;
          _context2.t1 = (0, _users.fetch)(_context2.t0);
          _context2.next = 9;
          return (0, _effects.put)(_context2.t1);

        case 9:
          _context2.next = 0;
          break;

        case 11:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this);
};

function fetchUsersOnSetPrimary() {
  return regeneratorRuntime.wrap(function fetchUsersOnSetPrimary$(_context3) {
    while (1) {
      switch (_context3.prev = _context3.next) {
        case 0:
          if (!true) {
            _context3.next = 11;
            break;
          }

          _context3.next = 3;
          return (0, _effects.take)(_members.SET_PRIMARY_SUCCESS);

        case 3:
          _context3.next = 5;
          return (0, _effects.select)(_members.memberSelector);

        case 5:
          _context3.t0 = _context3.sent;
          _context3.t1 = (0, _users.fetch)(_context3.t0);
          _context3.next = 9;
          return (0, _effects.put)(_context3.t1);

        case 9:
          _context3.next = 0;
          break;

        case 11:
        case 'end':
          return _context3.stop();
      }
    }
  }, _marked[2], this);
};

function invited() {
  var _ref, meta;

  return regeneratorRuntime.wrap(function invited$(_context4) {
    while (1) {
      switch (_context4.prev = _context4.next) {
        case 0:
          if (!true) {
            _context4.next = 15;
            break;
          }

          _context4.next = 3;
          return (0, _effects.take)(_users.INVITE_SUCCESS);

        case 3:
          _ref = _context4.sent;
          meta = _ref.meta;
          _context4.next = 7;
          return (0, _effects.put)((0, _frieze.info)('You have successfully invited ' + meta.email + '.'));

        case 7:
          _context4.next = 9;
          return (0, _effects.put)((0, _reactRouterRedux.push)('/member/access'));

        case 9:
          _context4.next = 11;
          return (0, _effects.put)((0, _reduxForm.reset)('users'));

        case 11:
          _context4.next = 13;
          return (0, _effects.put)((0, _search.clear)());

        case 13:
          _context4.next = 0;
          break;

        case 15:
        case 'end':
          return _context4.stop();
      }
    }
  }, _marked[3], this);
};